<?php

    class Set_Metadata_Action extends Reactor_Action
    {
        protected $tpl = 'set_metadata.php';
        protected $name = 'Set metadata value';
		
		public static $registration = array(
			ACTION_NAME => 'Set a metadata value',
			ACTION_CATEGORY => 'Nagios Reactor',
			ACTION_DESCRIPTION => 'Updates (or inserts) a key/value pair in the metadata table.',
			ACTION_AUTHOR => 'Jeremy Yunis, Nagios Enterprises, LLC',
			ACTION_VERSION => '1.0',
			ACTION_DATE => '02/15/2013', //Last version update
			ACTION_AUTHLEVEL => 0,  // 0 - everyone | 1 - Admin only
			ACTION_TYPE => 'core', //core | user. core modules can't be deleted
			ACTION_META => array(),	//Misc information	
		); 
		
        protected $fields = array(
            'key' => array(
                'label' => 'key',
                'validate' => 'trim|required|alpha_dash|xss_clean|prep_for_form',
            ),
            'value' => array(
                'label' => 'value',
                'validate' => 'required|xss_clean|prep_for_form',
            ),
        );

        public function get_label()
        {
            if($params = $this->get_params()) {
                if(array_key_exists('key', $params) &&
                        array_key_exists('value', $params)) {
                    return sprintf('Set metadata key \'%s\' to \'%s\'', $params['key'],$params['value']);
                }
            }
            return parent::get_label();
        }
       
        public function run($context)
        {
            $this->set_context($context);
            $params = $this->get_params();
            if(array_key_exists('key', $params) &&
                array_key_exists('value', $params)) {
                    $meta = array(
                        'key' => $params['key'],
                        'value' => $params['value']
                    );
                    $this->ci->metadata_model->create_or_update($meta);
            }
            $this->set_result(0);
            return $context;
        }
    }
